<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class CadastroIntegracaoService {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function updateToken($params) {
		
		$parameters = array(
			":NRORG"			=> $params['NRORG'],
			":CDFILIAL" 		=> $params['CDFILIAL'],
			":CDINTEGRACAO" 	=> $params["CDINTEGRACAO"],
			":IDTOKEN"			=> $params["IDTOKEN"],
			":IDTOKENBACKUP"	=> $params["IDTOKENBACKUP"],
			":DSTOKENFILI"		=> $params["DSTOKENFILI"],
			":IDRETTXENTR"		=> $params["IDRETTXENTR"],
			":IDUTLENTRETERC"   => $params["IDUTLENTRETERC"]
		);

		return $this->entityManager->getConnection()->executeQuery(self::UPDATE_TOKEN, $parameters);
	}
	
	public function removeToken($params) {
		
		$parameters = array(
			":NRORG"			=> $params['NRORG'],
			":CDFILIAL" 		=> $params['CDFILIAL'],
			":CDINTEGRACAO" 	=> $params["CDINTEGRACAO"],
			":IDTOKEN"			=> $params["IDTOKEN"]
		);

		return $this->entityManager->getConnection()->executeQuery(self::DELETE_TOKEN, $parameters);
	}
	
	    
	const UPDATE_TOKEN = "
		UPDATE INTEGRACAOFILI
		  SET
		    IDTOKEN		= :IDTOKEN,
		   DSTOKENFILI		= :DSTOKENFILI,
		   IDRETTXENTR		= :IDRETTXENTR,		
		   IDUTLENTRETERC	= :IDUTLENTRETERC 
		  WHERE 
		   CDINTEGRACAO 	= :CDINTEGRACAO AND
		   CDFILIAL 		= :CDFILIAL AND
		   IDTOKEN			= :IDTOKENBACKUP AND
		   NRORG			= :NRORG";
		   
	const DELETE_TOKEN = "
		DELETE FROM INTEGRACAOFILI
		  WHERE
		   IDTOKEN		= :IDTOKEN AND
		   CDINTEGRACAO = :CDINTEGRACAO AND
		   CDFILIAL 	= :CDFILIAL AND
		   NRORG		= :NRORG";
}