<?php
namespace Teknisa\MAN\Services; 

use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use \Setforms2\Shared\ORM\DateTime;

class ParametrosVenda {

    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function getParametros(){
    	$parametros = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_ALL_VND_PARAMETROS, $param);
    	return $parametros;
    }

    public function getHierarquiaParametros($nrorg){
    	$param = array('NRORG'=>$nrorg);
    	$hierarqParam = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_ALL_VND_HIERARQUIAPARAM, $param);
    	return $hierarqParam;
    }

    public function getParamValueByParam($param){
    	$nrparametro ='';
        $NRPARAMETRO        = $param[0]['value'];
    	$DESCRELACIONAMENTO = $param[1]['value'];
        $NRORG              = $param[2]['value'];

    	if($DESCRELACIONAMENTO == 'GERAL'){
    		$params = array('PARAMETRO'=>$NRPARAMETRO,
        				'RELACIONAMENTO'=>$DESCRELACIONAMENTO,
        				'NRORG'=>$NRORG);
    		$parametrosv = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PARAMVALUE_BYPARAM, $params);
    		if($parametrosv){
    			$nrparametro = $parametrosv[0]['PARAMETROV'];
    		}
    	}

    	if($DESCRELACIONAMENTO == 'TIPORECE'){
    		$valor              = $param[3]['value'];
			$arrayGet = array('PARAMETRO'=>$NRPARAMETRO, 'RELACIONAMENTO'=>$DESCRELACIONAMENTO, 'NRORG'=>$NRORG, 'VALOR'=>$valor);
			$getrelac = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PARAM_TIPORECE, $arrayGet);
			if($getrelac){
				$nrparametro = $getrelac[0]['VALORPARAMETRO'];
		    }
    	}
    	return $nrparametro;
    }

    public function getOpcaoParametro(){
    	$opcaoparam = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_ALLOPCAOPARAMETRO);
    	return $opcaoparam;
    }
    /**
     * saveParamValue
     * Antes de salvar são realizadas algumas validações:
     * Caso o parametro valor não esteja cadastrado ainda, haverá um insert na tabela
     * Caso o parametro valor já exista, haverá apenas um update
     */

    public function saveParamValue($params){
        $nrorg           = $params['NRORG'];
        $nrparametro     = $params['NRPARAMETRO'];
        $parametrovalor  = $params['PARAMETROVALOR'];
        $descrelac       = $params['DESCRELACIONAMENTO'];
        $operador        = $params['CDOPERADOR'];
        $valor           = $params['VALOR'];
        $cdfilial        = $params['CDFILIAL'];
        $cdloja          = $params['CDLOJA'];
        $cdcaixa         = $params['CDCAIXA'];
        $cdtiporece      = $params['CDTIPORECE'];
        $relac = false;
        $parametrovalor = self::trataParametroValor($parametrovalor);
        $arrayParamValue = array('NRPARAMETRO'=>$nrparametro, 'NRORG'=>$nrorg);
        $array= self::getNrparametroValor($arrayParamValue); 
        if(!empty($array)){ // todos os valores que o parametro pode ter 
            $arraygetRelac = array('DESCRELACIONAMENTO'=>$descrelac,'VALOR'=>$valor,
            'NRORG'=>$nrorg, 'NRPARAMETRO'=>$nrparametro);
            if($descrelac == 'CDFILIAL'){
                $relacionamento = self::getRelParametroValor($arraygetRelac, $descrelac); // relações para o relacionamento a ser inserido
                if(!empty($relacionamento)){
                    $novo = false;
                    $nrrelFilial = false;
                    for($k=0; $k<count($relacionamento); $k++){
                        $nrparametrovalor = $relacionamento[$k]['NRPARAMETROVALOR'];
                        $caixafind = self::getRelacionamentoByNrparamvalue($nrparametro, 'CDCAIXA', $nrorg, $nrparametrovalor);
                        $lojafind = self::getRelacionamentoByNrparamvalue($nrparametro, 'CDLOJA', $nrorg, $nrparametrovalor, $cdloja);
                        if(empty($caixafind) && empty($lojafind)){
                            $nrrelFilial = $relacionamento[$k]['NRRELPARAMETROVALOR'];
                            $novo = true;
                            $k = count($relacionamento);
                        }
                    }
                    if($novo == true){
                        $nrparametrovalornovo = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                        self::updateRelParametroValor($nrparametrovalornovo, $operador, $nrorg, $operador, $descrelac, $nrrelFilial);
                    }   
                    else{ // quando não há nenhum relacionamento a nível de filial, um novo é criado
                        $nrparametrovalor = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, $descrelac, $valor, $nrorg, $operador);
                    }
                }else{ // quando não há nenhum relacionamento a nível de filial, um novo é criado
                    $nrparametrovalor = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                    self::novoRelacparametroValor($nrparametrovalor, $descrelac, $valor, $nrorg, $operador);
                }
            }elseif($descrelac == 'CDLOJA'){
                $updateLoja = false; //caso a loja já exista e precisa apenas updatar. 
                $novoRegistro = true; //caso não exista a loja no registro.
                $nrrelFilial = false; 
                $arrayParamNR = array('NRPARAMETRO'=>$nrparametro);
                $numero1 = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PARAMETRO_BYNRPARAMETRO, $arrayParamNR);
                $arrayParam = array('CODPARAMETRO'=>$numero1[0]['CODPARAMETRO'], 'NRORG'=>$nrorg, 'DESCRELACIONAMENTO'=>'CDFILIAL', 'VALOR'=>$cdfilial);
                try {
                    // Busca todos os relacionamentos para a filial informada, em siguida busca qual filial se relaciona com a loja informada.
                    $valorParam = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PARAMETRO_BYDESCRELAC_VALOR, $arrayParam);
                    if($valorParam){
                        for($i=0; $i<count($valorParam); $i++){
                            $nrparametrovalor = $valorParam[$i]['NRPARAMETROVALOR'];
                            /*
                            Busca relacionamento de loja para o nrparametrovalor. Caso encontre relacionamento de loja e não encontre
                            de PDV retorna o array pois se trata de um relacionamento a nível de loja.
                            */
                            $arrayParamLoja = array('CODPARAMETRO'  =>$numero1[0]['CODPARAMETRO'], 
                                                'NRORG'         =>$params['NRORG'],
                                                'NRPARAMETROVALOR'=>$nrparametrovalor, 
                                                'DESCRELACIONAMENTO'=>'CDLOJA',
                                                'VALOR'=>$params['CDLOJA']
                            );
                            $resultLoja        = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PARAMETRO_BYNRPARAMETROVALOR_BYDESC_BYVALOR, $arrayParamLoja);
                            $arrayParamPDV = array('CODPARAMETRO'=>$numero1[0]['CODPARAMETRO'],
                                                   'NRORG'=>$params['NRORG'],
                                                   'NRPARAMETROVALOR'=>$nrparametrovalor,
                                                   'DESCRELACIONAMENTO'=>'CDCAIXA');

                            $resultPDV =  $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PARAMETRO_BYNRPARAMETROVALOR_BYDESC, $arrayParamPDV);  
                            if($resultLoja && empty($resultPDV)){
                                // UPDATE
                                // NOVOPARAMETROVALOR NA PARAMETROVALOR
                                // UPDATE RELPARAMETROVALOR
                                $nrrelFilial = $valorParam[$i]['NRRELPARAMETROVALOR'];
                                $novoRegistro = false; 
                                $updateLoja = $resultLoja[0]['NRRELPARAMETROVALOR'];
                                $i = count($valorParam);
                            }
                        }
                    }
                    if ($updateLoja){
                        $novoParametroValor = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                        self::updateRelParametroValor($novoParametroValor, $operador, $nrorg, $operador, 'CDFILIAL', $nrrelFilial);
                        self::updateRelParametroValor($novoParametroValor, $operador, $nrorg, $operador, 'CDLOJA', $updateLoja);
                    }elseif($novoRegistro){
                        $nrparametrovalor = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, 'CDFILIAL', $cdfilial, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, 'CDLOJA', $cdloja, $nrorg, $operador);
                    }
                }catch (\Exception $e){
                    var_dump($e);
                }
            }elseif($descrelac == 'CDCAIXA'){
                $relacionamento = self::getRelParametroValor($arraygetRelac, $descrelac); // relações para o relacionamento a ser inserido
                if(!empty($relacionamento)){
                    for($i=0; $i<count($relacionamento); $i++){
                        $nrparametrovalor = $relacionamento[$i]['NRPARAMETROVALOR'];
                        $filialfind = self::getRelacionamentoByDescrelacionamento($nrparametro, 'CDFILIAL', $nrorg, $nrparametrovalor, $cdfilial);
                        $lojafind = self::getRelacionamentoByDescrelacionamento($nrparametro, 'CDLOJA', $nrorg, $nrparametrovalor, $cdloja);
                        $caixafind = self::getRelacionamentoByDescrelacionamento($nrparametro, 'CDCAIXA', $nrorg, $nrparametrovalor, $cdcaixa);
                        if(!empty($filialfind) && !empty($lojafind) && !empty($caixafind)){ 
                            
                            // Já existe parametrização a nível de caixa
                            // O relacionamento já existente será updatado. Onde existe esse parametrovalor associado será updatado para o novo parametrovalor
                            $nrrelparametrovalorfilial = $filialfind[0]['NRRELPARAMETROVALOR'];
                            $nrrelparametrovalorloja   = $lojafind[0]['NRRELPARAMETROVALOR'];
                            $nrrelparametrovalorcaixa  = $caixafind[0]['NRRELPARAMETROVALOR'];
                            $novoParametroValor = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                            self::updateRelParametroValor($novoParametroValor, $operador, $nrorg, $operador, 'CDFILIAL', $nrrelparametrovalorfilial);
                            self::updateRelParametroValor($novoParametroValor, $operador, $nrorg, $operador, 'CDLOJA', $nrrelparametrovalorloja);
                            self::updateRelParametroValor($novoParametroValor, $operador, $nrorg, $operador, 'CDCAIXA', $nrrelparametrovalorcaixa);

                        }else{
                            $nrparametrovalor = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                            self::novoRelacparametroValor($nrparametrovalor, 'CDFILIAL', $cdfilial, $nrorg, $operador);
                            self::novoRelacparametroValor($nrparametrovalor, 'CDLOJA', $cdloja, $nrorg, $operador);
                            self::novoRelacparametroValor($nrparametrovalor, 'CDCAIXA', $cdcaixa, $nrorg, $operador);
                        }
                    }
                }else{
                    $nrparametrovalor = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                    self::novoRelacparametroValor($nrparametrovalor, 'CDFILIAL', $cdfilial, $nrorg, $operador);
                    self::novoRelacparametroValor($nrparametrovalor, 'CDLOJA', $cdloja, $nrorg, $operador);
                    self::novoRelacparametroValor($nrparametrovalor, 'CDCAIXA', $cdcaixa, $nrorg, $operador);
                }
            }elseif($descrelac == 'GERAL'){
                $arrayGeral = array('DESCRELACIONAMENTO'=>$descrelac, 'NRORG'=>$nrorg, 'NRPARAMETRO'=>$nrparametro);
                $relacionamento = self::getRelParametroValor($arrayGeral, $descrelac);
                
                if(!empty($relacionamento)){
                    $nrparametrovalornovo = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                    $nrrelparametrovalor = $relacionamento[0]['NRRELPARAMETROVALOR'];
                    self::updateRelParametroValor($nrparametrovalornovo, $operador, $nrorg, $operador, $descrelac, $nrrelparametrovalor);
                }else{
                    $nrrelparametro = self::getMaxNrrelacparametroValor();
                    $nrparametrovalornovo = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                    $arrayInsertRelParam = array('NRRELPARAMETROVALOR'=>intval($nrrelparametro),'NRPARAMETROVALOR'=>intval($nrparametrovalornovo),'DESCRELACIONAMENTO'=>$descrelac, 'VALOR'=>$valor, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                    self::insertRelParametroValor($arrayInsertRelParam);
                }
            }elseif($descrelac == 'TIPORECE'){
                $relacionamento = self::getRelParametroValor($arraygetRelac, $descrelac);
                if(!empty($relacionamento)){
                    $nrparametrovalornovo = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                    $nrrelparametrovalor = $relacionamento[0]['NRRELPARAMETROVALOR'];
                    self::updateRelParametroValor($nrparametrovalornovo, $operador, $nrorg, $operador, $descrelac, $nrrelparametrovalor);
                }else{
                    $nrrelparametro = self::getMaxNrrelacparametroValor();
                    $nrparametrovalornovo = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                    $arrayInsertRelParam = array('NRRELPARAMETROVALOR'=>intval($nrrelparametro),'NRPARAMETROVALOR'=>intval($nrparametrovalornovo),
                        'DESCRELACIONAMENTO'=>$descrelac, 'VALOR'=>$valor, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                    self::insertRelParametroValor($arrayInsertRelParam);
                }
            } else if ($descrelac == 'CDFILIAL_TIPORECE'){
                $arraygetRelac = array('DESCRELACIONAMENTO'=>'CDFILIAL','VALOR'=>$cdfilial,
                'NRORG'=>$nrorg, 'NRPARAMETRO'=>$nrparametro);
                $relacionamento = self::getRelParametroValor($arraygetRelac, 'CDFILIAL'); // relações para o relacionamento a ser inserido
                if(!empty($relacionamento)){
                    $novo = false;
                    $nrrelFilial = false;
                    $nrrelTiporece = false;
                    for($k=0; $k<count($relacionamento); $k++){
                        if ($relacionamento[$k]['VALOR'] == $cdfilial){
                            $nrparametrovalor = $relacionamento[$k]['NRPARAMETROVALOR'];
                            $lojafind =  self::getRelacionamentoByNrparamvalue($nrparametro, 'CDLOJA', $nrorg, $nrparametrovalor);
                            if (empty($lojafind)){
                                $tipofind =  self::getRelacionamentoByNrparamvalue($nrparametro, 'CDTIPORECE', $nrorg, $nrparametrovalor);
                                if ($tipofind[0]['VALOR'] == $cdtiporece){
                                    $novo = true;
                                    $nrrelFilial = $relacionamento[$k]['NRRELPARAMETROVALOR'];
                                    $nrrelTiporece = $tipofind[0]['NRRELPARAMETROVALOR'];
                                    $k = count($relacionamento);
                                }
                            }
                        }    
                    }
                    if($novo == true){
                        $nrparametrovalornovo = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                        self::updateRelParametroValor($nrparametrovalornovo, $operador, $nrorg, $operador, 'CDFILIAL', $nrrelFilial);
                        self::updateRelParametroValor($nrparametrovalornovo, $operador, $nrorg, $operador, 'CDTIPORECE', $nrrelTiporece);
                    }else{
                        $nrparametrovalor = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, 'CDFILIAL', $cdfilial, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, 'CDTIPORECE', $cdtiporece, $nrorg, $operador);
                    }
                }else{ // quando não há nenhum relacionamento a nível de filial e tiporece, um novo é criado
                        $nrparametrovalor = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, 'CDFILIAL', $cdfilial, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, 'CDTIPORECE', $cdtiporece, $nrorg, $operador);
                }
            }elseif($descrelac == 'CDLOJA_TIPORECE'){
                $arraygetRelac = array('DESCRELACIONAMENTO'=>'CDLOJA','VALOR'=>$cdloja,
                'NRORG'=>$nrorg, 'NRPARAMETRO'=>$nrparametro);
                $relacionamento = self::getRelParametroValor($arraygetRelac, 'CDLOJA'); // relações para o relacionamento a ser inserido
                if(!empty($relacionamento)){
                    $novo = false;
                    $tiporecefind = false;
                    $nrrelFilial = false;
                    $nrrelTiporece = false;
                    $nrrelLoja = false;
                    for($k=0; $k<count($relacionamento); $k++){
                        $nrparametrovalor = $relacionamento[$k]['NRPARAMETROVALOR'];
                        $filialfind = self::getRelacionamentoByDescrelacionamento($nrparametro, 'CDFILIAL', $nrorg, $nrparametrovalor, $cdfilial);
                        $tiporece = self::getRelacionamentoByNrparamvalue($nrparametro, 'CDTIPORECE', $nrorg, $nrparametrovalor);
                        if ($filialfind){
                            if ($filialfind[0]['VALOR'] == $cdfilial){
                                if($tiporece){
                                    if($tiporece[0]['VALOR'] == $cdtiporece){
                                        $tiporecefind = true;
                                        $nrrelFilial = $filialfind[0]['NRRELPARAMETROVALOR'];
                                        $nrrelTiporece = $tiporece[0]['NRRELPARAMETROVALOR'];
                                        $nrrelLoja = $relacionamento[$k]['NRRELPARAMETROVALOR'];
                                        $k = count($relacionamento);
                                    }
                                }                          
                            }
                        }
                    }    
                    if($tiporecefind){
                        // Já existe uma parametrização a nível de loja 
                        // O relacionamento já existente será updatado. Onde existe esse parametrovalor associado será updatado para o novo parametrovalor
                        $novoParametroValor = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                        self::updateRelParametroValor($novoParametroValor, $operador, $nrorg, $operador, 'CDFILIAL', $nrrelFilial);
                        self::updateRelParametroValor($novoParametroValor, $operador, $nrorg, $operador, 'CDLOJA', $nrrelLoja);
                        self::updateRelParametroValor($novoParametroValor, $operador, $nrorg, $operador, 'CDTIPORECE', $nrrelTiporece);                        
                    }else{
                        $nrparametrovalor = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, 'CDFILIAL', $cdfilial, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, 'CDLOJA', $cdloja, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, 'CDTIPORECE', $cdtiporece, $nrorg, $operador);
                    }
                    
                    
                }else{ // quando não há nenhum relacionamento a nível de filial e tiporece, um novo é criado
                        $nrparametrovalor = self::novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, 'CDFILIAL', $cdfilial, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, 'CDLOJA', $cdloja, $nrorg, $operador);
                        self::novoRelacparametroValor($nrparametrovalor, 'CDTIPORECE', $cdtiporece, $nrorg, $operador);
                }
            }
        }else{ // Não existe nenhum relacionamento para o parametro valor encontrado
            $nrparametrovalor = self::defineNrparametroValor($nrparametro, $parametrovalor, $nrorg, $operador);
            if($descrelac == 'GERAL'){
                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParam = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>$descrelac, 'VALOR'=>$valor, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParam);
            }elseif($descrelac == 'CDFILIAL'){
                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParam = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>$descrelac, 'VALOR'=>$valor, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParam);
            }elseif($descrelac == 'CDLOJA'){
                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParam = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>'CDFILIAL', 'VALOR'=>$cdfilial, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParam);
                
                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParam = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>$descrelac, 'VALOR'=>$cdloja, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParam);
            }elseif($descrelac == 'CDCAIXA'){
                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParamFilial = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>'CDFILIAL', 'VALOR'=>$cdfilial, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParamFilial);
                
                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParamLoja = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>'CDLOJA', 'VALOR'=>$cdloja, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParamLoja);
                
                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParamCaixa = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>$descrelac, 'VALOR'=>$cdcaixa, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParamCaixa);
            }elseif($descrelac == 'TIPORECE') {
                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParam = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>$descrelac, 'VALOR'=>$valor, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParam);
            }elseif($descrelac == 'CDFILIAL_TIPORECE'){
                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParam = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>'CDFILIAL', 'VALOR'=>$cdfilial, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParam);
                
                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParam = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>'CDTIPORECE', 'VALOR'=>$cdtiporece, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParam);
            }elseif($descrelac == 'CDLOJA_TIPORECE'){
                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParam = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>'CDFILIAL', 'VALOR'=>$cdfilial, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParam);
                
                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParam = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>'CDLOJA', 'VALOR'=>$cdloja, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParam);

                $nrrelparametro = self::getMaxNrrelacparametroValor();
                $arrayInsertRelParam = array('NRRELPARAMETROVALOR'=>$nrrelparametro,'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>'CDTIPORECE', 'VALOR'=>$cdtiporece, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
                self::insertRelParametroValor($arrayInsertRelParam);
            }
        }
    }

    public function getRelacionamentoByNrparamvalue($nrparametro, $descrelac, $nrorg, $nrparametrovalor){
		$param = null;
		try{
			$arrayGet = array('NRPARAMETRO'=>intval($nrparametro), 'DESCRELACIONAMENTO'=>$descrelac, 'NRORG'=>$nrorg, 'NRPARAMETROVALOR'=>intval($nrparametrovalor));
    		$param = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GETRELPARAMVALUE_SEMVALOR, $arrayGet);
 			if(!(empty($param))){
 				$nrparametrovalor = $param[0]['NRPARAMETROVALOR'];
 			}   	
    	}catch(\Exception $e){
			var_dump($e->getMessage());
    		$message = $e->getMessage();
		}
		return $param;
    }

    public function getRelacionamentoByDescrelacionamento($nrparametro, $descrelac, $nrorg, $nrparametrovalor, $valor){
		$param = null;
		try{
			$arrayGet = array('NRPARAMETRO'=>intval($nrparametro), 'DESCRELACIONAMENTO'=>$descrelac, 'NRORG'=>$nrorg, 'NRPARAMETROVALOR'=>intval($nrparametrovalor), 'VALOR'=>$valor);
    		$param = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GETRELPARAMVALOR_BYDESCRELACIONAMENTO, $arrayGet);
 			if(!(empty($param))){
 				$nrparametrovalor = $param[0]['NRPARAMETROVALOR'];
 			}   	
    	}catch(\Exception $e){
			var_dump($e->getMessage());
    		$message = $e->getMessage();
		}
		return $param;
    }

    public function novoParametroValor($nrparametro, $parametrovalor, $nrorg, $operador){
        $nrparametrovalor = self::getmaxParametroValor();
    	$arrayInsert = array('NRPARAMETROVALOR'=>intval($nrparametrovalor), 'NRPARAMETRO'=>intval($nrparametro), 
        'VALORPARAMETRO'=>$parametrovalor, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
        self::insertParametroValor($arrayInsert);
        return $nrparametrovalor;
    }

    public function novoRelacparametroValor($nrparametrovalor, $descrelac, $valor, $nrorg, $operador){
    	$nrrelparametrovalor = self::getMaxNrrelacparametroValor();
    	$arrayInsert = array('NRRELPARAMETROVALOR'=>$nrrelparametrovalor, 'NRPARAMETROVALOR'=>$nrparametrovalor, 'DESCRELACIONAMENTO'=>$descrelac,
    	'VALOR'=>$valor, 'NRORG'=>$nrorg, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
    	self::insertRelParametroValor($arrayInsert);
    }

    public function defineNrparametroValor($nrparametro, $parametrovalor, $nrorg, $operador){
    	// se o valor a ser atribuido ao parametro ja corresponder a um parametrovalor cadastrado p o parametro, havera somente um 
    	// update da tabela de relacionamento. Caso esse parametrovalor não exista, ele será criado só 
    	// depois ocorrerá o update 
    	$arrayGet = array('NRPARAMETRO'=>intval($nrparametro), 'VALORPARAMETRO'=>$parametrovalor, 'NRORG'=>$nrorg);
        $nrparametrovalor = self::getParametroValorCorrespondente($arrayGet); 
        if(!empty($nrparametrovalor)){


        }else{
        	$nrparametrovalor = self::getmaxParametroValor();
        	$arrayInsert = array('NRPARAMETROVALOR'=>intval($nrparametrovalor), 'NRPARAMETRO'=>intval($nrparametro), 
        		'VALORPARAMETRO'=>$parametrovalor, 'NRORGINCLUSAO'=>$nrorg, 'CDOPERINCLUSAO'=>$operador);
        	self::insertParametroValor($arrayInsert);
        } 
        return $nrparametrovalor;
    }

    public function getNrparametroValor($arrayParamValue){
    	$nrparametrovalor = null;
    	$array = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GETPARAMVALUE_BYNRPARAMETRO, $arrayParamValue);
       	return $array;
    }

    public function getRelParametroValor($arrayRelParamValue, $descrelac){
    	if($descrelac == 'GERAL'){
    		$array = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GETRELPARAMVALOR_BYNRPARAMETROVALOR_GERAL, $arrayRelParamValue);
    	}else{
    		$array = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GETRELPARAMVALOR_BYNRPARAMETROVALOR, $arrayRelParamValue);
    	}
    	return $array;
    }

    public function trataParametroValor($parametrovalor){
    	if($parametrovalor == 'Y'){
    		$parametrovalor = 'S';
    	}
    	if($parametrovalor == 'Homologação'){
    		$parametrovalor = 2;
    	}
    	if($parametrovalor == 'Produção'){
    		$parametrovalor = 1;
    	}
    	return $parametrovalor;
    }

    public function updateRelParametroValor($nrparametrovalor, $cdoperador, $nrorg, $operador, $descrelac, $nrrelparametrovalor){
		try{
			$arrayUpdate = array('NRPARAMETROVALOR'=>$nrparametrovalor, 'CDOPERULTATU'=>$cdoperador, 'NRORG'=>$nrorg,
				'DESCRELACIONAMENTO'=>$descrelac, 'NRRELPARAMETROVALOR'=>intval($nrrelparametrovalor));
			$this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_RELPARAMETROVALOR, $arrayUpdate);
		}catch(\Exception $e){
			var_dump($e->getMessage());
			$message = $e->getMessage();
		}
	}

	public function insertParametroValor($arrayInsert){
    	try{
    		$this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_PARAMETROVALOR, $arrayInsert);
    	}catch(\Exception $e){
			var_dump($e->getMessage());
			$message = $e->getMessage();
		}
	}

	public function insertRelParametroValor($arrayInsert){
		try{
    		$this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_RELPARAMETROVALOR, $arrayInsert);
    	}catch(\Exception $e){
			var_dump($e->getMessage());
    		$message = $e->getMessage();
		}
	}

	public function getmaxParametroValor(){
		$arrayMaxNrparametro = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_MAXNRPARAMETRO);
		$maxnrparametrovalor = $arrayMaxNrparametro[0]['MAX'];
		$nrparametrovalor = $maxnrparametrovalor + 1;
		return $nrparametrovalor;
	}

	public function getMaxNrrelacparametroValor(){
		$arrayMaxNrrelacparam = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_MAXNRRELPARAMETRO);
		$maxnrrelparametrovalor = $arrayMaxNrrelacparam[0]['MAX'];
		$nrrelparametrovalor = intval($maxnrrelparametrovalor) + 1;
		return $nrrelparametrovalor;
	}

	public function getParametroValorCorrespondente($arrayGet){
		$nrparametrovalor = null;
		try{
    		$param = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GETPARAMETROVALOR_BYVALORPARAMETRO, $arrayGet);
 			if(!(empty($param))){
 				$nrparametrovalor = $param[0]['NRPARAMETROVALOR'];
 			}   	
    	}catch(\Exception $e){
			var_dump($e->getMessage());
    		$message = $e->getMessage();
		}
		return $nrparametrovalor;
	}

	public function getTiporece($param){
    	$tiporece = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_TIPORECE, $param);
		return $tiporece;	
    }

    public function getParamValueFililoja($retorno){
    	$nrparametro = $retorno[0]['value'];;
	    $descrelac   = $retorno[1]['value'];
	    $nrorg       = $retorno[2]['value'];
	    $cdfilial    = $retorno[3]['value'];
	    $nivelRelacionamento = $retorno[4]['value'];
	    $cdcaixa     = $retorno[5]['value'];
	    $cdloja      = $retorno[6]['value'];
	    $nrvalorparam = '';
    	$param = array('PARAMETRO'=>$nrparametro, 'RELACIONAMENTO'=>$nivelRelacionamento, 'NRORG'=>$nrorg);
    	$getFilial = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PARAMVALUE_BYPARAM, $param);
        if($nivelRelacionamento == 'CDFILIAL'){
            for ($i=0; $i<count($getFilial); $i++){
                $nrparametrovalor = $getFilial[$i]['NRPARAMETROVALOR'];
                $filialGet = $getFilial[$i]['VALOR'];
                if ($cdfilial == $filialGet){
                    $lojafind = self::getRelacionamentoByNrparamvalue($nrparametro, 'CDLOJA', $nrorg, $nrparametrovalor);
                    if(empty($lojafind)){
                        $nrvalorparam = $getFilial[$i]['PARAMETROV'];
                        return $nrvalorparam;
                    }
                }
            }
        }elseif($nivelRelacionamento == 'CDLOJA'){
            for($i=0; $i<count($getFilial); $i++){
                $nrparametrovalor = $getFilial[$i]['NRPARAMETROVALOR'];
                $arrayGet = array('NRPARAMETRO'=>$nrparametro, 'NRORG'=>$nrorg,
                'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>$nivelRelacionamento,'VALOR'=>$cdloja);
                $getrelac = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GETRELPARAMVALOR_BYDESCRELACIONAMENTO, $arrayGet);
                if($getrelac){
                    $nrvalorparam = $getrelac[0]['VALORPARAMETRO'];
                    $i=count($getFilial);
                }
    		}
		}elseif($nivelRelacionamento == 'CDCAIXA'){
			for($i=0; $i<count($getFilial); $i++){
    			$nrparametrovalor = $getFilial[$i]['NRPARAMETROVALOR'];
    			$arrayGet = array('NRPARAMETRO'=>$nrparametro, 'NRORG'=>$nrorg,
    			'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>$nivelRelacionamento,'VALOR'=>$cdcaixa);
    			$getrelac = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GETRELPARAMVALOR_BYDESCRELACIONAMENTO, $arrayGet);
    			if($getrelac){
    				$nrvalorparam = $getrelac[0]['VALORPARAMETRO'];
    				$i=count($getFilial);
    			}
    		}
		}elseif($nivelRelacionamento == 'CDFILIAL_TIPORECE'){
	   		$cdtiporece  = $retorno[7]['value'];
			$param = array('PARAMETRO'=>$nrparametro, 'RELACIONAMENTO'=>'CDFILIAL', 'NRORG'=>$nrorg);
			$getFilial = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PARAMVALUE_BYPARAM, $param);		
            for($i=0; $i<count($getFilial); $i++){
                $filialGet = $getFilial[$i]['VALOR'];
                if ($cdfilial == $filialGet){
                    $nrparametrovalor = $getFilial[$i]['NRPARAMETROVALOR'];
                    $lojafind = self::getRelacionamentoByNrparamvalue($nrparametro, 'CDLOJA', $nrorg, $nrparametrovalor);
                    if(empty($lojafind)){
                        $arrayGet = array('NRPARAMETRO'=>$nrparametro, 'NRORG'=>$nrorg,
                        'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>'CDTIPORECE','VALOR'=>$cdtiporece);
                        $getrelac = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GETRELPARAMVALOR_BYDESCRELACIONAMENTO, $arrayGet);
                        if(!empty($getrelac)){
                            $nrvalorparam = $getrelac[0]['VALORPARAMETRO'];
                            $i=count($getFilial);
                        }
                    }
                }
            }
		}elseif($nivelRelacionamento == 'CDLOJA_TIPORECE'){
	   		$cdtiporece  = $retorno[7]['value'];
			$param = array('PARAMETRO'=>$nrparametro, 'RELACIONAMENTO'=>'CDFILIAL', 'NRORG'=>$nrorg);
			$getFilial = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PARAMVALUE_BYPARAM, $param);		
			for($i=0; $i<count($getFilial); $i++){
    			$nrparametrovalor = $getFilial[$i]['NRPARAMETROVALOR'];
    			$arrayGet = array('NRPARAMETRO'=>$nrparametro, 'NRORG'=>$nrorg,
    			'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>'CDLOJA','VALOR'=>$cdloja);
    			$getrelac = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GETRELPARAMVALOR_BYDESCRELACIONAMENTO, $arrayGet);
    			if($getrelac){
    				$arrayGetTiporece = array('NRPARAMETRO'=>$nrparametro, 'NRORG'=>$nrorg,
    				'NRPARAMETROVALOR'=>$nrparametrovalor,'DESCRELACIONAMENTO'=>'CDTIPORECE','VALOR'=>$cdtiporece);
    				$getrelacTiporece = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GETRELPARAMVALOR_BYDESCRELACIONAMENTO, $arrayGetTiporece);
    				if($getrelacTiporece){
    					$nrvalorparam = $getrelacTiporece[0]['VALORPARAMETRO'];
    				}
    			}
    		}
		}
    	    	
    	return $nrvalorparam;
    }

    public function getCliente($param){
    	$cliente = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_CLIENTES, $param);
		return $cliente;	
    }

    public function getFormpgto($param){
    	$formpgto = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_FORMPGTO, $param);
		return $formpgto;
    }

    public function getTipoBaixaRece($param){
    	$tipobaixaRece = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_TIPOBAIXARECE, $param);
   		return $tipobaixaRece;
    }
    
}
















