<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;

class RelRelacaoCuponsSatService {

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
  
    public function find($conditions) {
        $params = array(
            ":CDFILIAL"         => $conditions['CDFILIAL'],
            ":NRORG"            => $conditions['NRORG'],
            ":CDCAIXA"          => $conditions['CDCAIXA'],
            ":NRACESSONFCE"     => $conditions['NRACESSONFCE'],
            ":NRNOTAFISCALCE"   => $conditions['NRNOTAFISCALCE'],
            ":NRSEQVENDA"       => $conditions['NRSEQVENDA']
        );
        
        return $this->entityManager->getConnection()->fetchAll(self::GET_ITEM_VENDA, $params);
    }
    
    const GET_ITEM_VENDA = "
        SELECT IT.CDPRODUTO, P.NMPRODUTO, IT.QTPRODVEND, IT.VRUNITVEND, IT.CDCAIXA,  
               IT.NRSEQVENDA, IT.VRDESITVEND, IT.VRACRITVEND, IT.CDFILIAL, 
               (((IT.QTPRODVEND * IT.VRUNITVEND) + IT.VRACRITVEND) - IT.VRDESITVEND) AS VRTOTAL,
               (IT.CDFILIAL ||' - '||F.NMFILIAL ||' - '||'Caixa: '|| IT.CDCAIXA ||' - '||'Nr. Venda: '|| IT.NRSEQVENDA) AS UNIDADEGROUP
        FROM ITEMVENDA IT
        INNER JOIN VENDA V
            ON (IT.CDFILIAL      = V.CDFILIAL
            AND IT.CDCAIXA       = V.CDCAIXA
            AND IT.NRORG         = V.NRORG
            AND V.NRSEQVENDA     = IT.NRSEQVENDA)
        INNER JOIN FILIAL F
            ON (F.CDFILIAL       = IT.CDFILIAL
            AND F.NRORG          = V.NRORG)
        INNER JOIN PRODUTO P
            ON (P.CDPRODUTO      = IT.CDPRODUTO
            AND P.NRORG          = V.NRORG)
            WHERE IT.CDFILIAL    = :CDFILIAL
            AND IT.CDCAIXA       = :CDCAIXA
            AND V.NRACESSONFCE   = :NRACESSONFCE
            AND V.NRORG          = :NRORG
            AND V.NRSEQVENDA     = :NRSEQVENDA
    ";
}